diff --git a/gcc/m2/mc-boot/Galists.cc b/gcc/m2/mc-boot/Galists.cc
index 238bcc87d50..ca582f3ce43 100644
--- a/gcc/m2/mc-boot/Galists.cc
+++ b/gcc/m2/mc-boot/Galists.cc
@@ -42,9 +42,9 @@ along with GNU Modula-2; see the file COPYING3.  If not see
 #   undef NULL
 #   define NULL 0
 #endif
-#define _alists_H
 #define _alists_C
 
+#include "Galists.h"
 #   include "GStorage.h"
 
 typedef struct alists_performOperation_p alists_performOperation;
@@ -54,16 +54,13 @@ typedef struct alists__T1_r alists__T1;
 
 typedef struct alists__T2_a alists__T2;
 
-typedef alists__T1 *alists_alist;
-
-typedef void (*alists_performOperation_t) (void *);
-struct alists_performOperation_p { alists_performOperation_t proc; };
+typedef alists__T1 *alists_alist__opaque;
 
 struct alists__T2_a { void * array[MaxnoOfelements-1+1]; };
 struct alists__T1_r {
                       unsigned int noOfelements;
                       alists__T2 elements;
-                      alists_alist next;
+                      alists_alist__opaque next;
                     };
 
 
@@ -147,14 +144,14 @@ extern "C" bool alists_equalList (alists_alist left, alists_alist right);
    removeItem - remove an element at index, i, from the alist data type.
 */
 
-static void removeItem (alists_alist p, alists_alist l, unsigned int i);
+static void removeItem (alists_alist__opaque p, alists_alist__opaque l, unsigned int i);
 
 
 /*
    removeItem - remove an element at index, i, from the alist data type.
 */
 
-static void removeItem (alists_alist p, alists_alist l, unsigned int i)
+static void removeItem (alists_alist__opaque p, alists_alist__opaque l, unsigned int i)
 {
   l->noOfelements -= 1;
   while (i <= l->noOfelements)
@@ -176,12 +173,12 @@ static void removeItem (alists_alist p, alists_alist l, unsigned int i)
 
 extern "C" alists_alist alists_initList (void)
 {
-  alists_alist l;
+  alists_alist__opaque l;
 
   Storage_ALLOCATE ((void **) &l, sizeof (alists__T1));
   l->noOfelements = 0;
-  l->next = NULL;
-  return l;
+  l->next = static_cast<alists_alist__opaque> (NULL);
+  return static_cast<alists_alist> (l);
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
@@ -195,9 +192,9 @@ extern "C" void alists_killList (alists_alist *l)
 {
   if ((*l) != NULL)
     {
-      if ((*l)->next != NULL)
+      if (static_cast<alists_alist__opaque> ((*l))->next != NULL)
         {
-          alists_killList (&(*l)->next);
+          alists_killList (reinterpret_cast<alists_alist *> (&static_cast<alists_alist__opaque> ((*l))->next));
         }
       Storage_DEALLOCATE ((void **) &(*l), sizeof (alists__T1));
     }
@@ -210,21 +207,21 @@ extern "C" void alists_killList (alists_alist *l)
 
 extern "C" void alists_putItemIntoList (alists_alist l, void * c)
 {
-  if (l->noOfelements < MaxnoOfelements)
+  if (static_cast<alists_alist__opaque> (l)->noOfelements < MaxnoOfelements)
     {
-      l->noOfelements += 1;
-      l->elements.array[l->noOfelements-1] = c;
+      static_cast<alists_alist__opaque> (l)->noOfelements += 1;
+      static_cast<alists_alist__opaque> (l)->elements.array[static_cast<alists_alist__opaque> (l)->noOfelements-1] = c;
     }
-  else if (l->next != NULL)
+  else if (static_cast<alists_alist__opaque> (l)->next != NULL)
     {
       /* avoid dangling else.  */
-      alists_putItemIntoList (l->next, c);
+      alists_putItemIntoList (static_cast<alists_alist> (static_cast<alists_alist__opaque> (l)->next), c);
     }
   else
     {
       /* avoid dangling else.  */
-      l->next = alists_initList ();
-      alists_putItemIntoList (l->next, c);
+      static_cast<alists_alist__opaque> (l)->next = static_cast<alists_alist__opaque> (alists_initList ());
+      alists_putItemIntoList (static_cast<alists_alist> (static_cast<alists_alist__opaque> (l)->next), c);
     }
 }
 
@@ -237,17 +234,17 @@ extern "C" void * alists_getItemFromList (alists_alist l, unsigned int n)
 {
   while (l != NULL)
     {
-      if (n <= l->noOfelements)
+      if (n <= static_cast<alists_alist__opaque> (l)->noOfelements)
         {
-          return l->elements.array[n-1];
+          return static_cast<alists_alist__opaque> (l)->elements.array[n-1];
         }
       else
         {
-          n -= l->noOfelements;
+          n -= static_cast<alists_alist__opaque> (l)->noOfelements;
         }
-      l = l->next;
+      l = static_cast<alists_alist> (static_cast<alists_alist__opaque> (l)->next);
     }
-  return reinterpret_cast<void *> (0);
+  return static_cast<void *> (0);
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
@@ -270,9 +267,9 @@ extern "C" unsigned int alists_getIndexOfList (alists_alist l, void * c)
   else
     {
       i = 1;
-      while (i <= l->noOfelements)
+      while (i <= static_cast<alists_alist__opaque> (l)->noOfelements)
         {
-          if (l->elements.array[i-1] == c)
+          if (static_cast<alists_alist__opaque> (l)->elements.array[i-1] == c)
             {
               return i;
             }
@@ -281,7 +278,7 @@ extern "C" unsigned int alists_getIndexOfList (alists_alist l, void * c)
               i += 1;
             }
         }
-      return l->noOfelements+(alists_getIndexOfList (l->next, c));
+      return static_cast<alists_alist__opaque> (l)->noOfelements+(alists_getIndexOfList (static_cast<alists_alist> (static_cast<alists_alist__opaque> (l)->next), c));
     }
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
@@ -304,8 +301,8 @@ extern "C" unsigned int alists_noOfItemsInList (alists_alist l)
     {
       t = 0;
       do {
-        t += l->noOfelements;
-        l = l->next;
+        t += static_cast<alists_alist__opaque> (l)->noOfelements;
+        l = static_cast<alists_alist> (static_cast<alists_alist__opaque> (l)->next);
       } while (! (l == NULL));
       return t;
     }
@@ -335,33 +332,33 @@ extern "C" void alists_includeItemIntoList (alists_alist l, void * c)
 
 extern "C" void alists_removeItemFromList (alists_alist l, void * c)
 {
-  alists_alist p;
+  alists_alist__opaque p;
   unsigned int i;
   bool found;
 
   if (l != NULL)
     {
       found = false;
-      p = NULL;
+      p = static_cast<alists_alist__opaque> (NULL);
       do {
         i = 1;
-        while ((i <= l->noOfelements) && (l->elements.array[i-1] != c))
+        while ((i <= static_cast<alists_alist__opaque> (l)->noOfelements) && (static_cast<alists_alist__opaque> (l)->elements.array[i-1] != c))
           {
             i += 1;
           }
-        if ((i <= l->noOfelements) && (l->elements.array[i-1] == c))
+        if ((i <= static_cast<alists_alist__opaque> (l)->noOfelements) && (static_cast<alists_alist__opaque> (l)->elements.array[i-1] == c))
           {
             found = true;
           }
         else
           {
-            p = l;
-            l = l->next;
+            p = static_cast<alists_alist__opaque> (l);
+            l = static_cast<alists_alist> (static_cast<alists_alist__opaque> (l)->next);
           }
       } while (! ((l == NULL) || found));
       if (found)
         {
-          removeItem (p, l, i);
+          removeItem (p, static_cast<alists_alist__opaque> (l), i);
         }
     }
 }
@@ -377,9 +374,9 @@ extern "C" bool alists_isItemInList (alists_alist l, void * c)
 
   do {
     i = 1;
-    while (i <= l->noOfelements)
+    while (i <= static_cast<alists_alist__opaque> (l)->noOfelements)
       {
-        if (l->elements.array[i-1] == c)
+        if (static_cast<alists_alist__opaque> (l)->elements.array[i-1] == c)
           {
             return true;
           }
@@ -388,7 +385,7 @@ extern "C" bool alists_isItemInList (alists_alist l, void * c)
             i += 1;
           }
       }
-    l = l->next;
+    l = static_cast<alists_alist> (static_cast<alists_alist__opaque> (l)->next);
   } while (! (l == NULL));
   return false;
   /* static analysis guarentees a RETURN statement will be used before here.  */
@@ -421,19 +418,19 @@ extern "C" void alists_foreachItemInListDo (alists_alist l, alists_performOperat
 
 extern "C" alists_alist alists_duplicateList (alists_alist l)
 {
-  alists_alist m;
+  alists_alist__opaque m;
   unsigned int n;
   unsigned int i;
 
-  m = alists_initList ();
+  m = static_cast<alists_alist__opaque> (alists_initList ());
   n = alists_noOfItemsInList (l);
   i = 1;
   while (i <= n)
     {
-      alists_putItemIntoList (m, alists_getItemFromList (l, i));
+      alists_putItemIntoList (static_cast<alists_alist> (m), alists_getItemFromList (l, i));
       i += 1;
     }
-  return m;
+  return static_cast<alists_alist> (m);
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
@@ -475,10 +472,10 @@ extern "C" bool alists_equalList (alists_alist left, alists_alist right)
   __builtin_unreachable ();
 }
 
-extern "C" void _M2_alists_init (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_alists_init (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
 
-extern "C" void _M2_alists_fini (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_alists_fini (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
diff --git a/gcc/m2/mc-boot/Gdecl.h b/gcc/m2/mc-boot/Gdecl.h
index 67cd5b2e4d2..a237a25a3f6 100644
--- a/gcc/m2/mc-boot/Gdecl.h
+++ b/gcc/m2/mc-boot/Gdecl.h
@@ -246,6 +246,19 @@ EXTERN bool decl_isTypeHidden (decl_node n);
 
 EXTERN bool decl_hasHidden (decl_node n);
 
+/*
+   putTypeOpaque - marks type, des, as being an opaque type.
+                   TYPE des ;
+*/
+
+EXTERN void decl_putTypeOpaque (decl_node des);
+
+/*
+   isTypeOpaque - returns TRUE if type, n, is an opaque type.
+*/
+
+EXTERN bool decl_isTypeOpaque (decl_node n);
+
 /*
    isVar - returns TRUE if node, n, is a type.
 */
diff --git a/gcc/m2/mc-boot/Gkeyc.cc b/gcc/m2/mc-boot/Gkeyc.cc
index 0deb633d6b4..4a15f7b7371 100644
--- a/gcc/m2/mc-boot/Gkeyc.cc
+++ b/gcc/m2/mc-boot/Gkeyc.cc
@@ -42,9 +42,9 @@ Boston, MA 02110-1301, USA.  */
 #   undef NULL
 #   define NULL 0
 #endif
-#define _keyc_H
 #define _keyc_C
 
+#include "Gkeyc.h"
 #   include "GmcPretty.h"
 #   include "GStorage.h"
 #   include "GDynamicStrings.h"
@@ -1630,11 +1630,11 @@ extern "C" void keyc_cp (void)
     }
 }
 
-extern "C" void _M2_keyc_init (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_keyc_init (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
   init ();
 }
 
-extern "C" void _M2_keyc_fini (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_keyc_fini (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
diff --git a/gcc/m2/mc-boot/Gldtoa.h b/gcc/m2/mc-boot/Gldtoa.h
index df1f791b3bb..c4b4d904fb0 100644
--- a/gcc/m2/mc-boot/Gldtoa.h
+++ b/gcc/m2/mc-boot/Gldtoa.h
@@ -68,7 +68,7 @@ EXTERN long double ldtoa_strtold (void * s, bool *error);
            sign       does the string have a sign?
 */
 
-EXTERN void * ldtoa_ldtoa (long double d, ldtoa_Mode mode, int ndigits, int *decpt, bool *sign);
+EXTERN void * ldtoa_ldtoa (long double d, int mode, int ndigits, int *decpt, bool *sign);
 #   ifdef __cplusplus
 }
 #   endif
diff --git a/gcc/m2/mc-boot/Glists.cc b/gcc/m2/mc-boot/Glists.cc
index 4bfc310e8ce..dbbcd0eeb66 100644
--- a/gcc/m2/mc-boot/Glists.cc
+++ b/gcc/m2/mc-boot/Glists.cc
@@ -41,9 +41,9 @@ Boston, MA 02110-1301, USA.  */
 #   undef NULL
 #   define NULL 0
 #endif
-#define _lists_H
 #define _lists_C
 
+#include "Glists.h"
 #   include "GStorage.h"
 
 typedef struct symbolKey_performOperation_p symbolKey_performOperation;
@@ -53,16 +53,13 @@ typedef struct lists__T1_r lists__T1;
 
 typedef struct lists__T2_a lists__T2;
 
-typedef lists__T1 *lists_list;
-
-typedef void (*symbolKey_performOperation_t) (void *);
-struct symbolKey_performOperation_p { symbolKey_performOperation_t proc; };
+typedef lists__T1 *lists_list__opaque;
 
 struct lists__T2_a { void * array[MaxnoOfelements-1+1]; };
 struct lists__T1_r {
                      unsigned int noOfelements;
                      lists__T2 elements;
-                     lists_list next;
+                     lists_list__opaque next;
                    };
 
 
@@ -140,14 +137,14 @@ extern "C" lists_list lists_duplicateList (lists_list l);
    removeItem - remove an element at index, i, from the list data type.
 */
 
-static void removeItem (lists_list p, lists_list l, unsigned int i);
+static void removeItem (lists_list__opaque p, lists_list__opaque l, unsigned int i);
 
 
 /*
    removeItem - remove an element at index, i, from the list data type.
 */
 
-static void removeItem (lists_list p, lists_list l, unsigned int i)
+static void removeItem (lists_list__opaque p, lists_list__opaque l, unsigned int i)
 {
   l->noOfelements -= 1;
   while (i <= l->noOfelements)
@@ -169,12 +166,12 @@ static void removeItem (lists_list p, lists_list l, unsigned int i)
 
 extern "C" lists_list lists_initList (void)
 {
-  lists_list l;
+  lists_list__opaque l;
 
   Storage_ALLOCATE ((void **) &l, sizeof (lists__T1));
   l->noOfelements = 0;
-  l->next = NULL;
-  return l;
+  l->next = static_cast<lists_list__opaque> (NULL);
+  return static_cast<lists_list> (l);
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
@@ -188,9 +185,9 @@ extern "C" void lists_killList (lists_list *l)
 {
   if ((*l) != NULL)
     {
-      if ((*l)->next != NULL)
+      if (static_cast<lists_list__opaque> ((*l))->next != NULL)
         {
-          lists_killList (&(*l)->next);
+          lists_killList (reinterpret_cast<lists_list *> (&static_cast<lists_list__opaque> ((*l))->next));
         }
       Storage_DEALLOCATE ((void **) &(*l), sizeof (lists__T1));
     }
@@ -203,21 +200,21 @@ extern "C" void lists_killList (lists_list *l)
 
 extern "C" void lists_putItemIntoList (lists_list l, void * c)
 {
-  if (l->noOfelements < MaxnoOfelements)
+  if (static_cast<lists_list__opaque> (l)->noOfelements < MaxnoOfelements)
     {
-      l->noOfelements += 1;
-      l->elements.array[l->noOfelements-1] = c;
+      static_cast<lists_list__opaque> (l)->noOfelements += 1;
+      static_cast<lists_list__opaque> (l)->elements.array[static_cast<lists_list__opaque> (l)->noOfelements-1] = c;
     }
-  else if (l->next != NULL)
+  else if (static_cast<lists_list__opaque> (l)->next != NULL)
     {
       /* avoid dangling else.  */
-      lists_putItemIntoList (l->next, c);
+      lists_putItemIntoList (static_cast<lists_list> (static_cast<lists_list__opaque> (l)->next), c);
     }
   else
     {
       /* avoid dangling else.  */
-      l->next = lists_initList ();
-      lists_putItemIntoList (l->next, c);
+      static_cast<lists_list__opaque> (l)->next = static_cast<lists_list__opaque> (lists_initList ());
+      lists_putItemIntoList (static_cast<lists_list> (static_cast<lists_list__opaque> (l)->next), c);
     }
 }
 
@@ -230,17 +227,17 @@ extern "C" void * lists_getItemFromList (lists_list l, unsigned int n)
 {
   while (l != NULL)
     {
-      if (n <= l->noOfelements)
+      if (n <= static_cast<lists_list__opaque> (l)->noOfelements)
         {
-          return l->elements.array[n-1];
+          return static_cast<lists_list__opaque> (l)->elements.array[n-1];
         }
       else
         {
-          n -= l->noOfelements;
+          n -= static_cast<lists_list__opaque> (l)->noOfelements;
         }
-      l = l->next;
+      l = static_cast<lists_list> (static_cast<lists_list__opaque> (l)->next);
     }
-  return reinterpret_cast<void *> (0);
+  return static_cast<void *> (0);
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
@@ -263,9 +260,9 @@ extern "C" unsigned int lists_getIndexOfList (lists_list l, void * c)
   else
     {
       i = 1;
-      while (i <= l->noOfelements)
+      while (i <= static_cast<lists_list__opaque> (l)->noOfelements)
         {
-          if (l->elements.array[i-1] == c)
+          if (static_cast<lists_list__opaque> (l)->elements.array[i-1] == c)
             {
               return i;
             }
@@ -274,7 +271,7 @@ extern "C" unsigned int lists_getIndexOfList (lists_list l, void * c)
               i += 1;
             }
         }
-      return l->noOfelements+(lists_getIndexOfList (l->next, c));
+      return static_cast<lists_list__opaque> (l)->noOfelements+(lists_getIndexOfList (static_cast<lists_list> (static_cast<lists_list__opaque> (l)->next), c));
     }
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
@@ -297,8 +294,8 @@ extern "C" unsigned int lists_noOfItemsInList (lists_list l)
     {
       t = 0;
       do {
-        t += l->noOfelements;
-        l = l->next;
+        t += static_cast<lists_list__opaque> (l)->noOfelements;
+        l = static_cast<lists_list> (static_cast<lists_list__opaque> (l)->next);
       } while (! (l == NULL));
       return t;
     }
@@ -328,33 +325,33 @@ extern "C" void lists_includeItemIntoList (lists_list l, void * c)
 
 extern "C" void lists_removeItemFromList (lists_list l, void * c)
 {
-  lists_list p;
+  lists_list__opaque p;
   unsigned int i;
   bool found;
 
   if (l != NULL)
     {
       found = false;
-      p = NULL;
+      p = static_cast<lists_list__opaque> (NULL);
       do {
         i = 1;
-        while ((i <= l->noOfelements) && (l->elements.array[i-1] != c))
+        while ((i <= static_cast<lists_list__opaque> (l)->noOfelements) && (static_cast<lists_list__opaque> (l)->elements.array[i-1] != c))
           {
             i += 1;
           }
-        if ((i <= l->noOfelements) && (l->elements.array[i-1] == c))
+        if ((i <= static_cast<lists_list__opaque> (l)->noOfelements) && (static_cast<lists_list__opaque> (l)->elements.array[i-1] == c))
           {
             found = true;
           }
         else
           {
-            p = l;
-            l = l->next;
+            p = static_cast<lists_list__opaque> (l);
+            l = static_cast<lists_list> (static_cast<lists_list__opaque> (l)->next);
           }
       } while (! ((l == NULL) || found));
       if (found)
         {
-          removeItem (p, l, i);
+          removeItem (p, static_cast<lists_list__opaque> (l), i);
         }
     }
 }
@@ -370,9 +367,9 @@ extern "C" bool lists_isItemInList (lists_list l, void * c)
 
   do {
     i = 1;
-    while (i <= l->noOfelements)
+    while (i <= static_cast<lists_list__opaque> (l)->noOfelements)
       {
-        if (l->elements.array[i-1] == c)
+        if (static_cast<lists_list__opaque> (l)->elements.array[i-1] == c)
           {
             return true;
           }
@@ -381,7 +378,7 @@ extern "C" bool lists_isItemInList (lists_list l, void * c)
             i += 1;
           }
       }
-    l = l->next;
+    l = static_cast<lists_list> (static_cast<lists_list__opaque> (l)->next);
   } while (! (l == NULL));
   return false;
   /* static analysis guarentees a RETURN statement will be used before here.  */
@@ -414,27 +411,27 @@ extern "C" void lists_foreachItemInListDo (lists_list l, symbolKey_performOperat
 
 extern "C" lists_list lists_duplicateList (lists_list l)
 {
-  lists_list m;
+  lists_list__opaque m;
   unsigned int n;
   unsigned int i;
 
-  m = lists_initList ();
+  m = static_cast<lists_list__opaque> (lists_initList ());
   n = lists_noOfItemsInList (l);
   i = 1;
   while (i <= n)
     {
-      lists_putItemIntoList (m, lists_getItemFromList (l, i));
+      lists_putItemIntoList (static_cast<lists_list> (m), lists_getItemFromList (l, i));
       i += 1;
     }
-  return m;
+  return static_cast<lists_list> (m);
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
 
-extern "C" void _M2_lists_init (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_lists_init (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
 
-extern "C" void _M2_lists_fini (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_lists_fini (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
diff --git a/gcc/m2/mc-boot/GmcComment.cc b/gcc/m2/mc-boot/GmcComment.cc
index f17fb19a8e6..4c7650283ec 100644
--- a/gcc/m2/mc-boot/GmcComment.cc
+++ b/gcc/m2/mc-boot/GmcComment.cc
@@ -43,9 +43,9 @@ along with GNU Modula-2; see the file COPYING3.  If not see
 #   undef NULL
 #   define NULL 0
 #endif
-#define _mcComment_H
 #define _mcComment_C
 
+#include "GmcComment.h"
 #   include "GDynamicStrings.h"
 #   include "GStorage.h"
 #   include "GnameKey.h"
@@ -57,7 +57,7 @@ typedef struct mcComment__T1_r mcComment__T1;
 
 typedef enum {mcComment_unknown, mcComment_procedureHeading, mcComment_inBody, mcComment_afterStatement} mcComment_commentType;
 
-typedef mcComment__T1 *mcComment_commentDesc;
+typedef mcComment__T1 *mcComment_commentDesc__opaque;
 
 struct mcComment__T1_r {
                          mcComment_commentType type;
@@ -156,13 +156,13 @@ static DynamicStrings_String RemoveNewlines (DynamicStrings_String s);
                    in the comment.
 */
 
-static bool seenProcedure (mcComment_commentDesc cd, nameKey_Name procName);
+static bool seenProcedure (mcComment_commentDesc__opaque cd, nameKey_Name procName);
 
 /*
    dumpComment -
 */
 
-static void dumpComment (mcComment_commentDesc cd);
+static void dumpComment (mcComment_commentDesc__opaque cd);
 
 
 /*
@@ -212,7 +212,7 @@ static DynamicStrings_String RemoveNewlines (DynamicStrings_String s)
                    in the comment.
 */
 
-static bool seenProcedure (mcComment_commentDesc cd, nameKey_Name procName)
+static bool seenProcedure (mcComment_commentDesc__opaque cd, nameKey_Name procName)
 {
   DynamicStrings_String s;
   void * a;
@@ -235,7 +235,7 @@ static bool seenProcedure (mcComment_commentDesc cd, nameKey_Name procName)
    dumpComment -
 */
 
-static void dumpComment (mcComment_commentDesc cd)
+static void dumpComment (mcComment_commentDesc__opaque cd)
 {
   libc_printf ((const char *) "comment : ", 10);
   switch (cd->type)
@@ -282,7 +282,7 @@ static void dumpComment (mcComment_commentDesc cd)
 
 extern "C" mcComment_commentDesc mcComment_initComment (bool onlySpaces)
 {
-  mcComment_commentDesc cd;
+  mcComment_commentDesc__opaque cd;
 
   Storage_ALLOCATE ((void **) &cd, sizeof (mcComment__T1));
   mcDebug_assert (cd != NULL);
@@ -297,7 +297,7 @@ extern "C" mcComment_commentDesc mcComment_initComment (bool onlySpaces)
   cd->content = DynamicStrings_InitString ((const char *) "", 0);
   cd->procName = nameKey_NulName;
   cd->used = false;
-  return cd;
+  return static_cast<mcComment_commentDesc> (cd);
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
@@ -312,7 +312,7 @@ extern "C" void mcComment_addText (mcComment_commentDesc cd, void * cs)
 {
   if (cd != NULL)
     {
-      cd->content = DynamicStrings_ConCat (cd->content, DynamicStrings_InitStringCharStar (cs));
+      static_cast<mcComment_commentDesc__opaque> (cd)->content = DynamicStrings_ConCat (static_cast<mcComment_commentDesc__opaque> (cd)->content, DynamicStrings_InitStringCharStar (cs));
     }
 }
 
@@ -325,7 +325,7 @@ extern "C" DynamicStrings_String mcComment_getContent (mcComment_commentDesc cd)
 {
   if (cd != NULL)
     {
-      return cd->content;
+      return static_cast<mcComment_commentDesc__opaque> (cd)->content;
     }
   return static_cast<DynamicStrings_String> (NULL);
   /* static analysis guarentees a RETURN statement will be used before here.  */
@@ -365,10 +365,10 @@ extern "C" void mcComment_setProcedureComment (mcComment_commentDesc cd, nameKey
 {
   if (cd != NULL)
     {
-      if (seenProcedure (cd, procname))
+      if (seenProcedure (static_cast<mcComment_commentDesc__opaque> (cd), procname))
         {
-          cd->type = mcComment_procedureHeading;
-          cd->procName = procname;
+          static_cast<mcComment_commentDesc__opaque> (cd)->type = mcComment_procedureHeading;
+          static_cast<mcComment_commentDesc__opaque> (cd)->procName = procname;
         }
     }
 }
@@ -380,10 +380,10 @@ extern "C" void mcComment_setProcedureComment (mcComment_commentDesc cd, nameKey
 
 extern "C" DynamicStrings_String mcComment_getProcedureComment (mcComment_commentDesc cd)
 {
-  if ((cd->type == mcComment_procedureHeading) && ! cd->used)
+  if ((static_cast<mcComment_commentDesc__opaque> (cd)->type == mcComment_procedureHeading) && ! static_cast<mcComment_commentDesc__opaque> (cd)->used)
     {
-      cd->used = true;
-      return cd->content;
+      static_cast<mcComment_commentDesc__opaque> (cd)->used = true;
+      return static_cast<mcComment_commentDesc__opaque> (cd)->content;
     }
   return static_cast<DynamicStrings_String> (NULL);
   /* static analysis guarentees a RETURN statement will be used before here.  */
@@ -397,10 +397,10 @@ extern "C" DynamicStrings_String mcComment_getProcedureComment (mcComment_commen
 
 extern "C" DynamicStrings_String mcComment_getAfterStatementComment (mcComment_commentDesc cd)
 {
-  if ((cd->type == mcComment_afterStatement) && ! cd->used)
+  if ((static_cast<mcComment_commentDesc__opaque> (cd)->type == mcComment_afterStatement) && ! static_cast<mcComment_commentDesc__opaque> (cd)->used)
     {
-      cd->used = true;
-      return cd->content;
+      static_cast<mcComment_commentDesc__opaque> (cd)->used = true;
+      return static_cast<mcComment_commentDesc__opaque> (cd)->content;
     }
   return static_cast<DynamicStrings_String> (NULL);
   /* static analysis guarentees a RETURN statement will be used before here.  */
@@ -414,10 +414,10 @@ extern "C" DynamicStrings_String mcComment_getAfterStatementComment (mcComment_c
 
 extern "C" DynamicStrings_String mcComment_getInbodyStatementComment (mcComment_commentDesc cd)
 {
-  if ((cd->type == mcComment_inBody) && ! cd->used)
+  if ((static_cast<mcComment_commentDesc__opaque> (cd)->type == mcComment_inBody) && ! static_cast<mcComment_commentDesc__opaque> (cd)->used)
     {
-      cd->used = true;
-      return cd->content;
+      static_cast<mcComment_commentDesc__opaque> (cd)->used = true;
+      return static_cast<mcComment_commentDesc__opaque> (cd)->content;
     }
   return static_cast<DynamicStrings_String> (NULL);
   /* static analysis guarentees a RETURN statement will be used before here.  */
@@ -431,7 +431,7 @@ extern "C" DynamicStrings_String mcComment_getInbodyStatementComment (mcComment_
 
 extern "C" bool mcComment_isProcedureComment (mcComment_commentDesc cd)
 {
-  return (cd != NULL) && (cd->type == mcComment_procedureHeading);
+  return (cd != NULL) && (static_cast<mcComment_commentDesc__opaque> (cd)->type == mcComment_procedureHeading);
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
@@ -443,7 +443,7 @@ extern "C" bool mcComment_isProcedureComment (mcComment_commentDesc cd)
 
 extern "C" bool mcComment_isBodyComment (mcComment_commentDesc cd)
 {
-  return (cd != NULL) && (cd->type == mcComment_inBody);
+  return (cd != NULL) && (static_cast<mcComment_commentDesc__opaque> (cd)->type == mcComment_inBody);
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
@@ -455,15 +455,15 @@ extern "C" bool mcComment_isBodyComment (mcComment_commentDesc cd)
 
 extern "C" bool mcComment_isAfterComment (mcComment_commentDesc cd)
 {
-  return (cd != NULL) && (cd->type == mcComment_afterStatement);
+  return (cd != NULL) && (static_cast<mcComment_commentDesc__opaque> (cd)->type == mcComment_afterStatement);
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
 
-extern "C" void _M2_mcComment_init (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_mcComment_init (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
 
-extern "C" void _M2_mcComment_fini (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_mcComment_fini (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
diff --git a/gcc/m2/mc-boot/GmcComp.cc b/gcc/m2/mc-boot/GmcComp.cc
index 33c8201d8ad..02877639ad7 100644
--- a/gcc/m2/mc-boot/GmcComp.cc
+++ b/gcc/m2/mc-boot/GmcComp.cc
@@ -38,9 +38,9 @@ Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */
 #   undef NULL
 #   define NULL 0
 #endif
-#define _mcComp_H
 #define _mcComp_C
 
+#include "GmcComp.h"
 #   include "GFIO.h"
 #   include "Glibc.h"
 #   include "Gdecl.h"
@@ -562,7 +562,7 @@ static void pass (unsigned int no, decl_node n, mcComp_parserFunction f, decl_is
             {
               mcError_writeFormat0 ((const char *) "compilation failed", 18);
               mcLexBuf_closeSource ();
-              return ;
+              return;
             }
           mcLexBuf_closeSource ();
         }
@@ -651,11 +651,11 @@ extern "C" unsigned int mcComp_getPassNo (void)
   __builtin_unreachable ();
 }
 
-extern "C" void _M2_mcComp_init (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_mcComp_init (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
   init ();
 }
 
-extern "C" void _M2_mcComp_fini (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_mcComp_fini (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
diff --git a/gcc/m2/mc-boot/GmcDebug.cc b/gcc/m2/mc-boot/GmcDebug.cc
index f8919593199..154ae6926c1 100644
--- a/gcc/m2/mc-boot/GmcDebug.cc
+++ b/gcc/m2/mc-boot/GmcDebug.cc
@@ -24,9 +24,9 @@ Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */
        typedef struct { PROC_t proc; } PROC;
 #   endif
 
-#define _mcDebug_H
 #define _mcDebug_C
 
+#include "GmcDebug.h"
 #   include "GStrIO.h"
 #   include "GmcOptions.h"
 #   include "GmcError.h"
@@ -78,10 +78,10 @@ extern "C" void mcDebug_writeDebug (const char *a_, unsigned int _a_high)
     }
 }
 
-extern "C" void _M2_mcDebug_init (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_mcDebug_init (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
 
-extern "C" void _M2_mcDebug_fini (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
+extern "C" void _M2_mcDebug_fini (__attribute__((unused)) int argc, __attribute__((unused)) char *argv[], __attribute__((unused)) char *envp[])
 {
 }
